#[macro_use]
extern crate log;
extern crate shaman;
extern crate cdimage;
extern crate arrayvec;
extern crate rustc_serialize;

#[cfg(feature = "trace")]
#[macro_use]
extern crate lazy_static;

#[macro_use]
mod box_array;
#[macro_use]
mod serializer;
#[macro_use]
pub mod tracer;

pub mod gpu;
pub mod cdrom;
pub mod bios;
pub mod memory;
pub mod cpu;
pub mod shared;
pub mod padmemcard;
pub mod debugger;
pub mod assembler;
pub mod parallel_io;
pub mod debug_uart;

mod interrupt;
mod timekeeper;
mod spu;
mod mdec;

mod version {
    // VERSION and VERSION_CSTR are generated by build.rs
    include!(concat!(env!("OUT_DIR"), "/version.rs"));
}

pub use version::VERSION;
pub use version::VERSION_CSTR;
